unit Graildde;

interface

{Grail DDE Example
 CopyRight 1995 Argon D. Helm
 HomeQuest BBS 609-893-4031
 Portions extracted from Turbo Pascal Examples by Borland International

 Enjoy!
 }

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, Buttons, Dialogs, CredTbl {Credit table structure};

const
  DDE_fAckReq    = $8000;     {DDE Ack flags}
  DDE_fDeferUpd  = $4000;
  DDE_fRelease   = $2000;
  DDE_fRequested = $1000;
  DDE_fAck       = $0001;
  crlf           = Chr(13) + Chr(10);   {For the Memo component}

Type PDDEData = ^TDDEData;           {Struct for DDE data from grail}
  TDDEData = record
        Flags: Word;
	cfFormat: Integer;
        Value: array[0..0] of Char;
  end;


Type                                  {For request and initialization}
  DlgDataDescr = record
     StrApplic,StrTopic,StrItem,StrData: Array[0..79] of Char;
     StrResult : TCreditData;
end;

type                               {Object for dde to grail}
  TDDEForm = class(TForm)
    ddeInit: TSpeedButton;
    ddeTerm: TSpeedButton;
    ddeStatus: TLabel;
    ddeReq: TSpeedButton;
    ddeResults: TMemo;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ddeInitClick(Sender: TObject);
    procedure ddeTermClick(Sender: TObject);
    procedure ddeReqClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
 private
    DDEData : DlgDataDescr;
    ServerWindow: HWnd;
    PendingMessage: Word;
    GrailFmt: Word;
  public
    procedure InitiateDDE;
    procedure TerminateDDE;
    procedure RequestDDE(DataFormat:Word; Item:PChar);
  protected
    procedure ProcessData(Data: TCreditData);
    function  DecodeExcalDate(TheDate: LongInt; Format: Word): String;
    function  ConvertExcalMoney(Amount: LongInt): String;
    procedure WMDDEAck(var Msg: TMessage); Message  wm_DDE_Ack;
    procedure WMDDETerminate(var Msg: TMessage); Message  wm_DDE_Terminate;
    procedure WMDDEData(var Msg: TMessage); Message wm_DDE_Data;
  end;

var
  DDEForm: TDDEForm;

  {NOTE: In a plug-in you should never try to use dde to grail
  use the provided functions in the Alchemist WorkBench AlGralxxx ect.
 
  The thing about Excal dates is they are based on the number of
  MINS since 00/01/0001 instead of the number of DAYS since 01/01/0001
  and hence must be multipied by 1440 (number of mins in a day) in order
  to convert. Delphi times are based on the number of Days since 
  Day 1 Year 1.

  I didn't inlude a DDE Poke in this example. After all it was 
  mostly an exersize in DDE using the Windows API instead of 
  other, easier methods.

  The procs/functions I used to convert money and time are substandard
  and shouldn't be used in any serious application. But hey! they got
  the point accross for me. }


implementation

{$R *.DFM}


procedure TDDEForm.FormCreate(Sender: TObject);
begin
  ServerWindow := 0;
  PendingMessage := 0;
  StrCopy(DDEData.StrApplic, 'GRAIL');
  StrCopy(DDEData.StrTopic, 'GRAIL');
  StrCopy(DDEData.StrItem,'credit all id==0'); {Atom string for grial query}
                          {'credit id,UserId,first,middle,last,handle' +
                           ',Expire,Amount,Date,Processed,Card,Number,' +
                           'Approval,Item,Holder,Address id==0');}


GrailFmt := RegisterClipboardFormat('grail'); {Grab Tims cf format}
end;


procedure TDDEForm.InitiateDDE;  {Start conversation with grail
                               return error if fails}
 var
  AppAtom, TopicAtom: TAtom;
 begin
   PendingMessage := wm_DDE_Initiate;
   AppAtom := GlobalAddAtom(DDEData.StrApplic);
   TopicAtom := GlobalAddAtom(DDEData.StrTopic);
   SendMessage(HWND_BROADCAST, wm_DDE_Initiate, DDEForm.Handle,
    MakeLong(AppAtom, TopicAtom));
   GlobalDeleteAtom(AppAtom);
   GlobalDeleteAtom(TopicAtom);
   PendingMessage := 0;
  if ServerWindow = 0 then
    begin
    MessageBox(DDEForm.Handle, 'Cannot establish DDE link to Grail.',
                               'Error', mb_IconExclamation or mb_Ok);
    ddeStatus.Caption := 'Not Connected to Grail...Error';
    end;

  end;

procedure TDDEForm.WMDDEAck(var Msg: TMessage);  {Messages coming back}
 begin
  case PendingMessage of
    wm_DDE_Initiate:
      begin
        if ServerWindow = 0 then
          begin
          ServerWindow := Msg.WParam;
          ddeStatus.Caption := 'Connected to Grail... HWND: ' + IntToStr(ServerWindow);
          end
        else
        PostMessage(Msg.WParam, wm_DDE_Terminate, DDEForm.Handle, 0);
        GlobalDeleteAtom(Msg.LParamLo);
        GlobalDeleteAtom(Msg.LParamHi);
      end;
    wm_DDE_Execute:
      begin
        GlobalFree(Msg.LParamHi);
        PendingMessage := 0;
        DDEForm.SetFocus;
      end;
   wm_DDE_Request:
      begin
      GlobalDeleteAtom(Msg.LParamHi);
      MessageBox(DDEForm.Handle, 'DDE data not received',
        'Error', mb_IconExclamation or mb_Ok);
      end;
  end;
end;

procedure TDDEForm.TerminateDDE;    {Kill it}
 var
  W: HWnd;
 begin
  W := ServerWindow;
  ServerWindow := 0;   {This is the grail window handle}
  if IsWindow(W) then PostMessage(W, wm_DDE_Terminate, DDEForm.Handle, 0);
 end;

 procedure TDDEForm.RequestDDE(DataFormat:Word; Item:PChar);
 var
   lParam:LongInt;
   ItemGlobalAtom : TAtom;
   Executed : boolean;

begin
   Executed := false;
   ItemGlobalAtom := GlobalAddAtom(Item);
   lParam := ItemGlobalAtom;
   lParam := (lParam shl 16) or DataFormat; {format parameter so we have flags}
   if PostMessage(ServerWindow, wm_DDE_Request, DDEForm.Handle, lParam) then begin
      PendingMessage := wm_DDE_Request;
      Executed := True;
      ddeStatus.Caption := 'Request Processed...';
      end
   else begin
      GlobalDeleteAtom(ItemGlobalAtom);
   end;
   if not Executed then
     begin
     MessageBox(DDEForm.Handle, 'DDE request failed.',
       'Error', mb_IconExclamation or mb_Ok);
     ddeStatus.Caption := 'Request Failed';
     end;
   end;

 procedure TDDEForm.WMDDETerminate(var Msg: TMessage);
  begin
    if Msg.WParam = ServerWindow then
      TerminateDDE {In case request to terminate fails}
    else ddeStatus.Caption := 'DDE to Grail is Terminated...';
  end;

procedure TDDEForm.WMDDEData(var Msg: TMessage);
 var                             {This is where data comes back from grail}
   p:PDDEData;
   lParam : longint;
   DataRecord : TDDEdata;
   RetTData: TCreditData;
   Temp: Array[0..41] of Char;
 begin
   {GlobalGetAtomName(Msg.lParamHi, DDEData.StrItem, 79);}
      {When I took the above out it made the DDE from my program
       look the same as the DDE from Authur to Grail.}

   p:=GlobalLock(Msg.lParamLo);  {ptr to DDEdata}
   if p = nil then begin {we have to request}
      GlobalFree(Msg.lParamLo);
      GLobalDeleteAtom(Msg.lParamHi);
      RequestDDE(GrailFmt, DDEData.StrItem);
      exit;
   end;
   Move(P^,DataRecord,Sizeof(DataRecord));
   Move(P^.Value, RetTData, SizeOf(RetTData));  {Get Credit Info}

   GlobalUnlock(Msg.lParamLo);
   if (DataRecord.Flags or DDE_fRelease) <> 0 then
      GlobalFree(Msg.lParamLo);
   if (DataRecord.Flags or DDE_fAckReq) <> 0 then begin
      lParam:=DDE_FAckReq or (Msg.lParamHi shl 16);
      GlobalDeleteAtom(Msg.lParamHi);
   {if not PostMessage(ServerWindow,wm_DDE_Ack,DDEForm.Handle,lParam)  then
         GLobalDeleteAtom(Msg.lParamHi);} {use the old atom, just curious}
   end;
      ddeStatus.Caption := 'Data Recieved and ATOM Deleted.';
      ProcessData(RetTData);    {Put it all in a memo}

 end;

procedure TDDEForm.ProcessData(Data: TCreditData);
 var
    Temp: Array[0..41] of Char;
    MemoTemp: Array[0..130] of Char;

 begin
    StrLCopy(Temp, Data.HolderAddr, 120);
 ddeResults.Lines[0] :=  crlf + crlf + 'Holder Address: ' + StrPas(Temp);
    StrLCopy(Temp, Data.CardHolder, 40);
 ddeResults.Lines[0] :=  crlf + 'Card Holder: ' + StrPas(Temp);
    StrLCopy(Temp, Data.ItemPurch, 40);
 ddeResults.Lines[0] :=  crlf + 'Item Purchased: ' + StrPas(Temp);
     StrLCopy(Temp, Data.ApproveCode, 10);
 ddeResults.Lines[0] :=  crlf + 'Approval Code: ' + StrPas(Temp);
     StrLCopy(Temp, Data.CardNumber, 20);
 ddeResults.Lines[0] :=  crlf + 'Card Number: ' + StrPas(Temp);
     StrLCopy(Temp, Data.CardName, 20);
 ddeResults.Lines[0] :=  crlf + 'Card Name: ' + StrPas(Temp);
 ddeResults.Lines[0] :=  crlf + 'Card Processed: ' +
                            DecodeExcalDate(Data.ExpirationDate, 1);
 ddeResults.Lines[0] :=  crlf + 'Credit Posted: ' +
                            DecodeExcalDate(Data.CreditPosted, 1);
 ddeResults.Lines[0] :=  crlf +
                           'Credit Amount: ' + ConvertExcalMoney(Data.AmountCredit);
 ddeResults.Lines[0] :=  crlf + 'Card Expires: ' +
                            DecodeExcalDate(Data.ExpirationDate, 0);
     StrLCopy(Temp, Data.Handle, 20);
 ddeResults.Lines[0] :=  crlf + 'User Handle: ' + StrPas(Temp);
    StrLCopy(Temp, Data.Last, 20);
 ddeResults.Lines[0] :=  crlf + 'Last Name: ' + StrPas(Temp);
    StrLCopy(Temp, Data.Middle, 20);
 ddeResults.Lines[0] := crlf + 'Middle Name: ' + StrPas(Temp);
    StrLCopy(Temp, Data.First, 20);
 ddeResults.Lines[0] := crlf + 'First Name: ' + StrPas(Temp);
    ddeResults.Lines[0] := 'Transaction ID: ' + IntToStr(Data.id);
 ddeResults.Lines[0] := crlf + 'User Id: ' + IntToStr(Data.UserId);
 end;

function  TDDEForm.DecodeExcalDate(TheDate: LongInt; Format: Word): String;
 var Day, Month, Year: Word;
       DateToDecode: TDateTime;

 begin
          {Carefull here I don't know how the difference in the
           windows international date settings will affect this
           it may need tweeking but don't have time to check...
           it has worked on about 20 changes to the date in
           my dummy record}

     DateToDecode := (00/01/0001 + (TheDate / 1440));
     DecodeDate(DateToDecode, Year, Month, Day);

    case Format of

      0:   Result := IntToStr(Month) + '/' + IntToStr(Year);
      1:   Result := IntToStr(Month) + '/' + IntToStr(Day) + '/' + IntToStr(Year);

      else Result := 'Invalid or Empty';

    end;

 end;

function  TDDEForm.ConvertExcalMoney(Amount: LongInt): String;
  var MakeDollars: Real;

  begin
       {This routine must be modified to account for
        penny values when the value
        is float.}

   if (Amount > 0) and (Amount < 100) then
      begin
       Result := IntToStr(Amount) + 'Cents';
       exit;
      end
      else
         begin
          MakeDollars := (Amount / 100);
          Result := '$' + FloatToStr(MakeDollars);
          exit;
         end;

         Result := '$0.00';
 end;

procedure TDDEForm.ddeInitClick(Sender: TObject);
begin
InitiateDDE;
end;

procedure TDDEForm.ddeTermClick(Sender: TObject);
begin
TerminateDDE;
end;



procedure TDDEForm.ddeReqClick(Sender: TObject);

begin
RequestDDE(GrailFmt, DDEData.StrItem);
end;

procedure TDDEForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if ServerWindow <> 0 then TerminateDDE;
end;

end.
